package myclasses;

import myenums.FacultyName;

public class Faculty extends OrganizationalUnit {
	private String dean;
	private int numberOfStudents;
	
	public Faculty(FacultyName name, int numberOfEmployees, int numberOfStudents) {
		super(name.name(), numberOfEmployees);
		this.numberOfStudents = numberOfStudents;
		switch(name) {
			case GEIK : this.dean = "Simonfalvi Zoltan"; break;
			case MFK : this.dean = "Szucs Peter"; break;
			case MAK : this.dean = "Palotas Arpad"; break;
			case GTK : this.dean = "Somosi Mariann"; break;
			case AJK : this.dean = "Csak Csilla"; break;
		}
	}
	
	public Faculty(FacultyName name) {
		this(name, 70, 500);
	}
	
	
	@Override
	public double workPerEmployee() {
		return numberOfStudents/getNumberOfEmployees();
	};

	@Override
	public String toString() {
		return "Faculty [dean=" + dean + ", numberOfStudents=" + numberOfStudents + 
				", numberOfStudentsPerEmployee=" + workPerEmployee() +
				", toString()=" + super.toString() + "]";
	}

	public String getDean() {
		return dean;
	}

	public void setDean(String dean) {
		this.dean = dean;
	}

	public int getNumberOfStudents() {
		return numberOfStudents;
	}

	public void setNumberOfStudents(int numberOfStudents) {
		this.numberOfStudents = numberOfStudents;
	}
	
	
}
