package myclasses.runnable;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import myclasses.*;
import myenums.FacultyName;

public class Test {

	public static void main(String[] args) {

		OrganizationalUnit[] units = new OrganizationalUnit[5];
		units[0] = new Library(30, 100000);
		units[1] = new Faculty(FacultyName.MFK);
		units[2] = new Faculty(FacultyName.GEIK, 150, 1800);
		units[3] = new Faculty(FacultyName.GTK, 130, 1200);
		units[4] = new Faculty(FacultyName.AJK, 100, 1000);

		/*
		 * listArray(units); Arrays.sort(units,
		 * Comparator.comparing(OrganizationalUnit::getNumberOfEmployees));
		 * listArray(units);
		 * 
		 * //Legnagyobb kar System.out.println("Legnagyobb kar: " +
		 * units[biggestFaculty(units)].getName()); //sszes hallgati ltszm
		 * System.out.println("sszes hallgat: " + sumOfStudents(units));
		 */

		/*********************************************************************************/
		// Binris keresshez Comparator
		Comparator<OrganizationalUnit> c = new Comparator<OrganizationalUnit>() {
			public int compare(OrganizationalUnit u1, OrganizationalUnit u2) {
				return u1.getName().compareTo(u2.getName());
			}
		};

		// Binris keress rendezett tmbben
		Arrays.sort(units, Comparator.comparing(OrganizationalUnit::getName));
		int index = Arrays.binarySearch(units, new Faculty(FacultyName.MFK, 0, 0), c);
		System.out.println(index);

		// Tmb talaktsa dinamikus listv
		List<OrganizationalUnit> unitlist = new ArrayList<>(Arrays.asList(units));
		unitlist.sort(Comparator.comparing(OrganizationalUnit::getName));
		list(unitlist);
		index = Collections.binarySearch(unitlist, new Faculty(FacultyName.MFK, 0, 0), c);
		System.out.println(index);

		unitlist.add(new Library(1, 1000));
		list(unitlist);
		System.out.println("Lista mrete: " + unitlist.size());

		OrganizationalUnit[] units2 = new OrganizationalUnit[unitlist.size()];
		unitlist.toArray(units2);
		listArray(units2);

		unitlist.remove(units2[5]);
		list(unitlist);
		System.out.println("Eleme-e a listnak? " + unitlist.contains(units2[5]));
		System.out.println("Lista mrete: " + unitlist.size());

		unitlist.subList(2, 4).clear();
		list(unitlist);
		System.out.println("Lista mrete: " + unitlist.size());

		unitlist.clear();
		System.out.println("res a lista? " + unitlist.isEmpty());
		System.out.println("Lista mrete: " + unitlist.size());

	}

	public static void listArray(OrganizationalUnit[] units) {
		for (OrganizationalUnit o : units)
			System.out.println(o);
		System.out.println();
	}

	public static void list(List<OrganizationalUnit> unitlist) {
		for (OrganizationalUnit o : unitlist)
			System.out.println(o);
		System.out.println();
	}

	public static int biggestFaculty(OrganizationalUnit[] units) {
		int i;
		for (i = 0; i < units.length; i++) {
			if (units[i] instanceof Faculty)
				break;
		}
		int maxindex = -1;
		if (i < units.length) {
			maxindex = i;
			for (int j = i + 1; j < units.length; j++) {
				if (units[j] instanceof Faculty) {
					if (units[j].workPerEmployee() > units[maxindex].workPerEmployee()) {
						maxindex = j;
					}
				}
			}
		}
		return maxindex;
	}

	public static int sumOfStudents(OrganizationalUnit[] units) {
		int sum = 0;
		for (OrganizationalUnit o : units) {
			if (o instanceof Faculty)
				sum += ((Faculty) o).getNumberOfStudents();
		}
		return sum;
	}
}
