package harmadik;

public class CarAnonymous {

    String brand;
    int year;
    String registrationNumber;
    
    interface Checkable {
        public void formatCheck(String registrationNumber);
        public String getFormattedString();
    }
    
    public CarAnonymous(String brand, int year, String registrationNumber) {
		super();
		this.brand = brand;
		this.year = year;
		if (checkRegistrationNumber(registrationNumber))
			this.registrationNumber = registrationNumber;
		else
			this.registrationNumber = "";
	}
   
	@Override
	public String toString() {
		return "Car [brand=" + brand + ", year=" + year + ", registrationNumber=" + registrationNumber + "]";
	}

	public String getBrand() {
		return brand;
	}

	public void setBrand(String brand) {
		this.brand = brand;
	}

	public int getYear() {
		return year;
	}

	public void setYear(int year) {
		this.year = year;
	}

	public String getRegistrationNumber() {
		return registrationNumber;
	}

	public void setRegistrationNumber(String registrationNumber) { 
		if (checkRegistrationNumber(registrationNumber))
			this.registrationNumber = registrationNumber;
		else
			this.registrationNumber = "";
	}

	/*****************************************************/
	
	static String regularExpression = "[^A-Z][^A-Z][^A-Z][^0-9][^0-9][^0-9]";

	public static boolean checkRegistrationNumber(String registrationNumber){

		final int registrationNumberLength = 6;
		       
		Checkable checkable = new Checkable() {
            
            String formattedRegistrationNumber = null;

            public void formatCheck(String registrationNumber){
                String currentRegistrationNumber = registrationNumber.replaceAll(
                  regularExpression, "");
                if (currentRegistrationNumber.length() == registrationNumberLength) {
                    formattedRegistrationNumber = currentRegistrationNumber;
                }
                else {
                	formattedRegistrationNumber = null;
                }
            }
            
            public String getFormattedString() {
            	return formattedRegistrationNumber;
            }
		};
		
		checkable.formatCheck(registrationNumber);
		if (checkable.getFormattedString()==null)
			return false;
		else
			return true;
	}
	
}
