package masodik;

public class FunctionSolver extends Function{

/*
    public LinearFunctionSolver getLinearFunctionSolver(LinearFunction linearFunction){
        return new LinearFunctionSolver(linearFunction);
    }
*/

    public class LinearFunctionSolver{

        double result;

        public LinearFunctionSolver(LinearFunction function) {
            this.result = solveLinearFunction(function);
        }

        public double getResult() {
            return result;
        }

        private double solveLinearFunction(LinearFunction function){
            if (function.getA() != 0 && function.getB() != 0)
            	return -function.getB()/function.getA();
            else 
            	return 0;

        }
    }

    public class QuadraticFunctionSolver{
        
    	double resultPlus;
        double resultMinus;
        boolean solvable;
        
        public double getResultPlus() {
			return resultPlus;
		}

        public double getResultMinus() {
			return resultMinus;
		}

		public boolean isSolvable() {
			return solvable;
		}
		
        public QuadraticFunctionSolver(QuadraticFunction function) {
            if(calculateDiscriminant(function)>=0) {
            	solvable = true;
                solveQuadraticFunction(function);
            }
            else
            	solvable = false;
        }

        private void solveQuadraticFunction(QuadraticFunction function) {

        	double D = calculateDiscriminant(function);
            if (D>0){
            	resultMinus=-(function.getB() - Math.sqrt(D))/(2*function.getA());
                resultPlus=-(function.getB() + Math.sqrt(D))/(2*function.getA());
            }
            else if (D==0){
                resultMinus=resultPlus=-(function.getB())/(2*function.getA());
            }
        }

        private double calculateDiscriminant(QuadraticFunction function) {
        	return Math.pow(function.getB(),2)-4*function.getA()*function.getC();
        }
    }
    
}
