package negyedik;


public class QuadraticPolynomial implements Polynomial {
	double a;
	double b;
	double c;
	final static int degree = 2;
	
	public QuadraticPolynomial(double a, double b, double c) {
		super();
		this.a = a;
		this.b = b;
		this.c = c;
	}

	/*  Másodfokú polinom y=ax^2+bx+c  */
	@Override
	public double calculate(double x) {
		return (a*x*x+b*x+c);
	}

	@Override
	public int getDegree() {
		return degree;
	}

	@Override
	public String toString() {
		return "y = "+a+"x^2 + ("+b+"x) + ("+c+")";
	}
	
	public double calculateDiscriminant() {
		return (b*b)-4*a*c;
	}
	
	public static enum Solution {REAL_1, REAL_2, COMPLEX_2}
	
	private Solution getSolutionType() {
		if(this.calculateDiscriminant()== 0)
			return Solution.REAL_1;
		else if (this.calculateDiscriminant() > 0) 
			return Solution.REAL_2;
		else
			return Solution.COMPLEX_2;
	}
	
	public void calculateSolution() {
		Solution type = getSolutionType();
		switch(type) {
			case REAL_1 : System.out.println("Egy valós megoldás: " + calculateSolutionReal1()); break;
			case REAL_2 : System.out.println("Két valós megoldás: " + calculateSolutionReal2().getX1()
											+ ", " + calculateSolutionReal2().getX2()); break;
			case COMPLEX_2 : System.out.println("Két komplex megoldás: " + calculateSolutionComplex2()); break;
		}
	}
	
	private double calculateSolutionReal1() {
		return -b / (2*a);
	}
	
	public class RealRoot {
		double x1;
		double x2;
		public RealRoot(double x1, double x2) { this.x1 = x1; this.x2 = x2; }
		public double getX1() { return x1; }
		public double getX2() { return x2; }
		public String toString() {
			return  x1 + ", " + x2;
		}
	}
	
	private RealRoot calculateSolutionReal2() {
		double x1 = -b + Math.sqrt(calculateDiscriminant()) / (2*a);
		double x2 = -b - Math.sqrt(calculateDiscriminant()) / (2*a);
		RealRoot solution = new RealRoot(x1, x2);
		return solution;
	}
	
	public class ComplexRoot {
		Complex x1;
		Complex x2;
		public ComplexRoot(Complex x1, Complex x2) { this.x1 = x1; this.x2 = x2; }
		public Complex getX1() { return x1; }
		public Complex getX2() { return x2; }
		public String toString() {
			return  x1 + ", " + x2;
		}
	}
	
	private ComplexRoot calculateSolutionComplex2() {
		double real = -b / (2*a);
		double im = Math.sqrt(Math.abs(calculateDiscriminant())) / (2*a);
		Complex x1 = new Complex(real, im);
		Complex x2 = new Complex(real, -im);
		ComplexRoot solution = new ComplexRoot(x1, x2);
		return solution;
	}
}
