package fajlkezeles;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Comparator;

public class Test {

	public static void main(String[] args) {
		File in = new File("adatok.txt");
		ArrayList<String> data = new ArrayList<String>();

		data.add("Nagy Erzsebet");
		data.add("Kozsup Bence");
		data.add("Kristaly CSanad Endre");
		data.add("En");

		data.sort(Comparator.naturalOrder());

		for (String string : data) {
			System.out.println(string.toString());
		}

		try {
			writeInFile(in, data);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		System.out.println();
		
		ArrayList<String> data2 = new ArrayList<String>();
		try {
			data2 = readFromFile(in);
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		for (String string : data2) {
			System.out.println(string.toString());
		}
		
		System.out.println();
		
		data2.remove("En");
		try {
			writeInFile(in, data2);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		data2.add("Valaki");
		data2.sort(Comparator.naturalOrder());

		try {
			writeInFile(in, data2);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		

	}

	private static void writeInFile(File file, ArrayList<String> names) throws IOException {
		// Ha a FileWriter konstruktornak msodik argumentuma true,
		// nem fellrja a fjlt, hanem append = true
		FileWriter fileWriter = new FileWriter(file);
		try {
			for (String name : names) {
				fileWriter.write(name + "\n");
			}
			fileWriter.flush();
		} catch (IOException e) {
			System.out.println("Error in writing file...");
		} finally {
			if (fileWriter != null)
				fileWriter.close();
		}
	}

	private static ArrayList<String> readFromFile(File file) throws IOException {
		ArrayList<String> names = new ArrayList<String>();
		FileReader fileReader = new FileReader(file);
		BufferedReader reader = new BufferedReader(fileReader);
		String line;
		
		try {
			while ((line = reader.readLine()) != null) {
				names.add(line);
			}
		} catch (IOException e) {
			System.out.println("Error in reading file...");
		} finally {
			reader.close();
		}
		
		return names;
	}

}
