package mypackage;

import java.util.Comparator;

public class Employee extends Person {
	private String workplace;
	private int salary;
	
	public Employee(String name, int age, String workplace, int salary) {
		super(name, age);
		this.workplace = workplace;
		this.salary = salary;
	}

	public String getWorkplace() {
		return workplace;
	}

	public void setWorkplace(String workplace) {
		this.workplace = workplace;
	}

	public int getSalary() {
		return salary;
	}

	public void setSalary(int salary) {
		this.salary = salary;
	}

	@Override
	public String toString() {
		return "Employee [workplace=" + workplace + ", salary=" + salary + ", toString()=" + super.toString() + "]";
	}
	
	//Nested static class
	public static class AgeSorter implements Comparator<Employee> {
		@Override
		public int compare(Employee e1, Employee e2) {
			return e1.getAge() - e2.getAge();
		}
	}
	
	//Nested static class 2
	public static class SalarySorter implements Comparator<Employee> {
		@Override
		public int compare(Employee e1, Employee e2) {
			return e1.getSalary() - e2.getSalary();
		}
	}
}
